program install;

{Freeware by Henning Associates}

{This code is a no frills windows installation program.  Using a single
 input disk, the program will install the specified files from
 the disk and create a program group and item for the installed software.
 The installation is customized using the constant items below.}

{The program has been updated to include the ability to update and existing
 program.  For my purposes that meant updateing the EXE and HLP files but
 not messing with the databases.}

{$X+}

uses windos, strings, wintypes, winprocs, wobjects, wincrt;

const
   {Installation window title}
   programtoinstall = 'Yellow Sticky Installation';
   {Default directory}
   directory = 'C:\YLWSTKY';
   {Default Group Name}
   group = 'Yellow Sticky';
   {Program Icon title}
   icontitle = 'Yellow Sticky v3.09';
   {number of files to install}
   numfiles = 3;
   {Names of the files to install, the executable file must be first on the
    list}
   filestocopy : array[1..numfiles] of string =
      ('ylwstky.exe',
       'ylwstky.hlp',
       'todo.db');
   {number of files to include in program update}
   numupdate = 2;
   {names of files to include in program update}
   filestoupdate : array[1..numupdate] of string =
      ('ylwstky.exe',
       'ylwstky.hlp');

   id_button_1 = 101;
   id_button_2 = 102;
   id_static_1 = 103;
   id_static_2 = 104;
   id_static_3 = 107;
   id_edit_1 = 105;
   id_edit_2 = 106;

type

   prinstallwin = ^trinstallwin;
   trinstallwin = object(twindow)
      serverwindow : hwnd;
      pendingmessage : word;
      constructor init(atitle:pchar);
      procedure setupwindow; virtual;

      procedure initiatedde;
      procedure terminatedde;
      procedure wmddeack(var msg:tmessage);virtual wm_first+wm_dde_ack;
      procedure wmddeterminate(var msg:tmessage);virtual wm_first+wm_dde_terminate;
      procedure wmdestroy(var msg:tmessage);virtual wm_first+wm_destroy;

      procedure install(var msg:tmessage);virtual id_first+id_button_1;
      procedure cancel(var msg:tmessage);virtual id_first+id_button_2;
      procedure msginstall(var msg:tmessage);virtual wm_first+id_button_1;
      procedure msgcancel(var msg:tmessage);virtual wm_first+id_button_2;
   end;

   tinstallapp = object(tapplication)
      procedure initmainwindow; virtual;
   end;

   predit = ^tredit;
   tredit = object(tedit)
      CatchReturn: Boolean;
      procedure WMChar(var Msg: TMessage);
         virtual wm_First + wm_Char;
      procedure WMKeyDown(var Msg: TMessage);
         virtual wm_First + wm_KeyDown;
      procedure WMKeyup(var Msg: TMessage);
         virtual wm_First + wm_Keyup;
      procedure wmsyschar(var msg:tmessage);
         virtual wm_first + wm_syschar;
   end;

   prbutton = ^trbutton;
   trbutton = object(tbutton)
      CatchReturn: Boolean;
      procedure WMChar(var Msg: TMessage);
         virtual wm_First + wm_Char;
      procedure WMKeyDown(var Msg: TMessage);
         virtual wm_First + wm_KeyDown;
      procedure WMKeyup(var Msg: TMessage);
         virtual wm_First + wm_Keyup;
      procedure wmsyschar(var msg:tmessage);
         virtual wm_first + wm_syschar;
   end;


var
   inst : tinstallapp;
   button_1, button_2 : prbutton;
   static_1, static_2, static_3 : pstatic;
   edit_1, edit_2 : predit;

   directory_val : array[0..64] of char;
   group_val : array[0..32] of char;
   size : word;
   shift : boolean;

{*************************************************************************}
{                        trinstallwin methods                             }
{*************************************************************************}

constructor trinstallwin.init(atitle:pchar);

begin
   twindow.init(nil,atitle);
   attr.x := 50;
   attr.y := 50;
   attr.w := 300;
   attr.h := 250;
end;

procedure trinstallwin.setupwindow;
begin
   twindow.setupwindow;
   initiatedde;
   setfocus(edit_1^.hwindow);
end;

procedure trinstallwin.initiatedde;

var
   appatom, topicatom : tatom;
begin
   serverwindow := 0;
   pendingmessage := wm_dde_initiate;
   appatom := globaladdatom('progman');
   topicatom := globaladdatom('progman');
   sendmessage(hwnd(-1),wm_dde_initiate,hwindow,makelong(appatom, topicatom));
   globaldeleteatom(appatom);
   globaldeleteatom(topicatom);
   pendingmessage := 0;
   if serverwindow = 0 then
   begin
      messagebox(hwindow, 'Cannot establish DDE link to Program Manager.',
      'Error',mb_iconexclamation or mb_ok);
      postquitmessage(0);
   end;
end;

procedure trinstallwin.terminatedde;

var
   w : hwnd;
begin
   w := serverwindow;
   serverwindow := 0;
   if iswindow(w) then
      postmessage(w,wm_dde_terminate,hwindow,0);
end;

procedure trinstallwin.wmddeack(var msg:tmessage);
begin
   case pendingmessage of
     wm_dde_initiate:
     begin
        if serverwindow = 0 then
           serverwindow := msg.wparam
        else
           postmessage(msg.wparam,wm_dde_terminate,hwindow,0);
        globaldeleteatom(msg.lparamlo);
        globaldeleteatom(msg.lparamhi);
        pendingmessage := 0;
     end;
     wm_dde_execute:
     begin
        globalfree(msg.lparamhi);
        pendingmessage := 0;
        messagebox(hwindow,'Installation Complete','Done',mb_ok);
        postquitmessage(0);

     end;
   end;
end;

procedure trinstallwin.wmddeterminate(var msg:tmessage);
begin
   if msg.wparam = serverwindow then terminatedde;
end;

procedure trinstallwin.wmdestroy(var msg:tmessage);
begin
   terminatedde;
   twindow.wmdestroy(msg);
end;

procedure trinstallwin.install(var msg:tmessage);

type
   fbuffer = array[0..1023] of byte;
var
   start, stop : integer;
   hcommands : thandle;
   pcommands : pchar;
   totalsize : real;
   sizewritten : real;
   infile, outfile : file;
   i : integer;
   tempstring : array[0..100] of char;
   executefile : array[0..100] of char;
   pbuffer : ^fbuffer;
   numread, numwritten : integer;
   percentdone : array[0..15] of char;


begin
   edit_1^.gettext(@directory_val,64);
   if directory_val[strlen(directory_val)-1] = '\' then
      directory_val[strlen(directory_val)-1] := #0;
   edit_2^.gettext(@group_val,32);

   {copy files}
   createdir(@directory_val);
   case doserror of
      0 : {directory does not exist}
      begin
         {get size of files}
         totalsize := 0;
         for i := 1 to numfiles do
         begin
            {$I-}
            assign(infile,filestocopy[i]);
            reset(infile);
            if ioresult <> 0 then
            begin
               messagebox(hwindow,'Source file error','File Error',mb_iconstop+mb_ok);
               postquitmessage(0);
               exit;
            end;
           totalsize := totalsize+(filesize(infile)*128);
           close(infile);
         end;
         new(pbuffer); {get memory to read}
         sizewritten := 0;
         for i := 1 to numfiles do
         begin
            assign(infile,filestocopy[i]);
            reset(infile,1);
            if ioresult <> 0 then
            begin
               messagebox(hwindow,'Source file error','File Error',mb_iconstop+mb_ok);
               postquitmessage(0);
               exit;
            end;
            strcopy(@tempstring,@directory_val);
            strcat(@tempstring,'\');
            strpcopy(@tempstring[strlen(tempstring)],filestocopy[i]);
            if i = 1 then
               strcopy(executefile,tempstring);
            assign(outfile,tempstring);
            rewrite(outfile,1);
            if ioresult <> 0 then
            begin
               messagebox(hwindow,'Destination file error','File Error',mb_iconstop+mb_ok);
               postquitmessage(0);
               exit;
            end;
            repeat
               blockread(infile,pbuffer^,1024,numread);
               if ioresult <> 0 then
               begin
                  messagebox(hwindow,'Source file error','File Error',mb_iconstop+mb_ok);
                  postquitmessage(0);
                  exit;
               end;
               sizewritten := sizewritten + numread;
               blockwrite(outfile,pbuffer^,numread,numwritten);
               if ioresult <> 0 then
               begin
                  messagebox(hwindow,'Destination file error','File Error',mb_iconstop+mb_ok);
                  postquitmessage(0);
                  exit;
               end;
               str(((sizewritten/totalsize)*100):2:0,percentdone);
               strcat(percentdone,'% Done');
               static_3^.settext(percentdone);
            until (numread = 0) or (numread <> numwritten);
            close(infile);
            close(outfile);
         end;
      end;
      5 : {directory exists}
      begin
         {get size of files}
         totalsize := 0;
         for i := 1 to numupdate do
         begin
            {$I-}
            assign(infile,filestoupdate[i]);
            reset(infile);
            if ioresult <> 0 then
            begin
               messagebox(hwindow,'Source file error','File Error',mb_iconstop+mb_ok);
               postquitmessage(0);
               exit;
            end;
           totalsize := totalsize+(filesize(infile)*128);
           close(infile);
         end;
         if messagebox(hwindow,'Path already exists.  Do you want to update the files other than the database?',
            'Directory Already Exists',mb_iconquestion+mb_yesno) = id_yes then
         begin
            new(pbuffer); {get memory to read}
            sizewritten := 0;
            for i := 1 to numupdate do
            begin
               assign(infile,filestoupdate[i]);
               reset(infile,1);
               if ioresult <> 0 then
               begin
                  messagebox(hwindow,'Source file error','File Error',mb_iconstop+mb_ok);
                  postquitmessage(0);
                  exit;
               end;
               strcopy(@tempstring,@directory_val);
               strcat(@tempstring,'\');
               strpcopy(@tempstring[strlen(tempstring)],filestocopy[i]);
               if i = 1 then
                  strcopy(executefile,tempstring);
               assign(outfile,tempstring);
               rewrite(outfile,1);
               if ioresult <> 0 then
               begin
                  messagebox(hwindow,'Destination file error','File Error',mb_iconstop+mb_ok);
                  postquitmessage(0);
                  exit;
               end;
               repeat
                  blockread(infile,pbuffer^,1024,numread);
                  if ioresult <> 0 then
                  begin
                     messagebox(hwindow,'Source file error','File Error',mb_iconstop+mb_ok);
                     postquitmessage(0);
                     exit;
                  end;
                  sizewritten := sizewritten + numread;
                  blockwrite(outfile,pbuffer^,numread,numwritten);
                  if ioresult <> 0 then
                  begin
                     messagebox(hwindow,'Destination file error','File Error',mb_iconstop+mb_ok);
                     postquitmessage(0);
                     exit;
                  end;
                  str(((sizewritten/totalsize)*100):2:0,percentdone);
                  strcat(percentdone,'% Done');
                  static_3^.settext(percentdone);
               until (numread = 0) or (numread <> numwritten);
               close(infile);
               close(outfile);
            end;
         end
         else begin
            postquitmessage(0);
            exit;
         end;
      end

      else
      begin
         strcopy(@tempstring,'Can not create directory ');
         strcat(@tempstring,@directory_val);
         messagebox(hwindow,@tempstring,'Directory Error',mb_iconstop+mb_ok);
         postquitmessage(0);
         exit;
      end;
   end;
   {$I+}

   {create group and item}
   if (serverwindow <> 0) and (pendingmessage = 0) then
   begin
      hcommands := globalalloc(gmem_moveable or gmem_ddeshare,200);
      if hcommands <> 0 then
      begin
         pcommands := globallock(hcommands);
         strcopy(pcommands,'[CreateGroup(');
         strcat(pcommands,@group_val);
         strcat(pcommands,')][ShowGroup(');
         strcat(pcommands,@group_val);
         strcat(pcommands,',1)][AddItem(');
         strcat(pcommands,@executefile);
         strcat(pcommands,',');
         strcat(pcommands,icontitle);
         strcat(pcommands,',');
         strcat(pcommands,@executefile);
         strcat(pcommands,',0)]');
         globalunlock(hcommands);
         if postmessage(serverwindow,wm_dde_execute,hwindow,makelong(0,hcommands)) then
         begin
            pendingmessage := wm_dde_execute;
         end else
         begin
            globalfree(hcommands);
         end;
      end;
   end;
end;   

procedure trinstallwin.cancel(var msg:tmessage);
begin
   postquitmessage(0);
end;

procedure trinstallwin.msginstall(var msg:tmessage);
begin
   install(msg);
end;

procedure trinstallwin.msgcancel(var msg:tmessage);
begin
   cancel(msg);
end;

{*************************************************************************}
{                            tredit methods                               }
{*************************************************************************}

procedure trEdit.WMChar(var Msg: TMessage);
begin
  { Only trap returns in single line edit boxes }
  if not CatchReturn then
    DefWndProc(Msg)
  else
end; { TrEdit.WMChar }

procedure trEdit.WMKeyDown(var Msg: TMessage);
var
  Focused: THandle;
begin
  catchreturn := false;
  case msg.wparam of
     vk_return:
     begin
        CatchReturn := (Attr.Style and es_MultiLine = 0) and
                 (Msg.wParam = vk_Return);
        if CatchReturn then
           postmessage(application^.mainwindow^.hwindow,id_button_1,0,0)
        else
           defwndproc(msg);
     end;
     vk_shift:
     begin
        shift := true;
     end;
     vk_tab:
     begin
        if not shift then
           SetFocus(GetNextDlgTabItem(Parent^.HWindow, HWindow, False))
        else
           setfocus(getnextdlgtabitem(parent^.hwindow,hwindow,true));
        catchreturn := true;
     end;
     else
        DefWndProc(Msg);
  end {case}
end; { TrEdit.WMKeyDown }

procedure tredit.wmkeyup(var msg:tmessage);
begin
   if msg.wparam = vk_shift then
      shift := false;
   defwndproc(msg);
end;

procedure tredit.wmsyschar(var msg:tmessage);
begin
   if (msg.wparam = ord('C')) or (msg.wparam = ord('c')) then
      postmessage(application^.mainwindow^.hwindow,id_button_2,0,0)
   else
      if (msg.wparam = ord('I')) or (msg.wparam = ord('i')) then
         postmessage(application^.mainwindow^.hwindow,id_button_1,0,0)
      else
         defwndproc(msg);
end;

{*************************************************************************}
{                          trbutton methods                               }
{*************************************************************************}

procedure trbutton.WMChar(var Msg: TMessage);
begin
  { Only trap returns in single line edit boxes }
  if not CatchReturn then
     DefWndProc(Msg)
  else
end; { TrEdit.WMChar }

procedure trbutton.WMKeyDown(var Msg: TMessage);
var
  Focused: THandle;
begin
  catchreturn := false;
  case msg.wparam of
     vk_return:
     begin
        CatchReturn := (Attr.Style and es_MultiLine = 0) and
                 (Msg.wParam = vk_Return);
        if CatchReturn then
        { If so, move to next control }
           if @self = button_1 then
              postmessage(application^.mainwindow^.hwindow,id_button_1,0,0)
           else
              postmessage(application^.mainwindow^.hwindow,id_button_2,0,0)
        else
           defwndproc(msg);
     end;
     vk_shift:
     begin
        shift := true;
     end;
     vk_tab:
     begin
        if not shift then
           SetFocus(GetNextDlgTabItem(Parent^.HWindow, HWindow, False))
        else
           setfocus(getnextdlgtabitem(parent^.hwindow,hwindow,true));
        catchreturn := true;
     end;
     else
        DefWndProc(Msg);
  end {case}
end;

procedure trbutton.wmkeyup(var msg:tmessage);
begin
   if msg.wparam = vk_shift then
      shift := false;
   defwndproc(msg);
end;

procedure trbutton.wmsyschar(var msg:tmessage);
begin
   if (msg.wparam = ord('C')) or (msg.wparam = ord('c')) then
      postmessage(application^.mainwindow^.hwindow,id_button_2,0,0)
   else
      if (msg.wparam = ord('I')) or (msg.wparam = ord('i')) then
         postmessage(application^.mainwindow^.hwindow,id_button_1,0,0)
      else
         defwndproc(msg);
end;

{*************************************************************************}
{                         tinstallapp methods                             }
{*************************************************************************}

procedure tinstallapp.initmainwindow;

begin
   mainwindow := new(prinstallwin,init(programtoinstall));
   button_1 := new(prbutton,init(mainwindow,id_button_1,'&Install',50,175,75,25,true));
   button_2 := new(prbutton,init(mainwindow,id_button_2,'&Cancel',175,175,75,25,false));
   static_1 := new(pstatic,init(mainwindow,id_static_1,'Directory',10,10,100,15,9));
   static_2 := new(pstatic,init(mainwindow,id_static_2,'Group Name',10,70,100,15,10));
   static_3 := new(pstatic,init(mainwindow,id_static_3,'0% Done',100,130,100,15,7));
   edit_1 := new(predit,init(mainwindow,id_edit_1,directory,20,25,250,25,64,FALSE));
   edit_2 := new(predit,init(mainwindow,id_edit_2,group,20,85,250,25,32,FALSE));

end;

{ Main program }

begin
  shift := false;
  inst.Init(programtoinstall);
  inst.Run;
  inst.done;
end.
